var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Directive, HostListener, EventEmitter, Input, ElementRef, Output, HostBinding } from '@angular/core';
import { FontAwesome } from './../../commons/classes/font-awesome.class';
import { DomAttr } from './../../commons/extends/attr.class';
var ButtonDirective = /** @class */ (function (_super) {
    __extends(ButtonDirective, _super);
    /**
     * construnct
     *
     * @param {ElementRef} el Directive target document
     */
    function ButtonDirective(el) {
        var _this = _super.call(this) || this;
        _this.el = el;
        _this.load = new EventEmitter();
        _this.outline = null;
        _this.lg = null;
        _this.sm = null;
        _this.loading = null;
        _this.icon = new FontAwesome('spinner', true).toHtmlString();
        return _this;
    }
    Object.defineProperty(ButtonDirective.prototype, "_disabled", {
        get: function () {
            return this.disabled || this.loading === true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ButtonDirective.prototype, "_class", {
        get: function () {
            return this.btnClass + " " + (this.class || '');
        },
        enumerable: true,
        configurable: true
    });
    ButtonDirective.prototype.onClick = function () {
        this.present();
        this.load.emit(this);
    };
    /**
     * Directive init hook
     */
    ButtonDirective.prototype.ngOnInit = function () {
        this.button = this.el.nativeElement;
        this.button.type = 'button';
    };
    /**
     * Show loading icon
     */
    ButtonDirective.prototype.present = function () {
        if (this.loading !== null && !this.hasLoadingIcon()) {
            this.button.innerHTML = this.icon + this.button.innerHTML;
            this.loading = true;
        }
    };
    /**
     * Remove loading icon
     */
    ButtonDirective.prototype.dismiss = function () {
        if (this.hasLoadingIcon()) {
            this.button.removeChild(this.button.childNodes[0]);
            this.button.innerHTML = this.button.innerHTML.replace("<!-- " + this.icon + " -->", '');
            this.loading = false;
        }
    };
    /**
     * Check loading icon
     */
    ButtonDirective.prototype.hasLoadingIcon = function () {
        return this.button.innerHTML.indexOf("<!-- " + this.icon + " -->") >= 0;
    };
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], ButtonDirective.prototype, "loading", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], ButtonDirective.prototype, "class", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], ButtonDirective.prototype, "load", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Boolean)
    ], ButtonDirective.prototype, "disabled", void 0);
    __decorate([
        HostBinding('disabled'),
        __metadata("design:type", Boolean),
        __metadata("design:paramtypes", [])
    ], ButtonDirective.prototype, "_disabled", null);
    __decorate([
        HostBinding('class'),
        __metadata("design:type", String),
        __metadata("design:paramtypes", [])
    ], ButtonDirective.prototype, "_class", null);
    __decorate([
        HostListener('click', ['$event']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], ButtonDirective.prototype, "onClick", null);
    ButtonDirective = __decorate([
        Directive({
            selector: "button[tsBtn]",
            exportAs: 'tsBtn'
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], ButtonDirective);
    return ButtonDirective;
}(DomAttr));
export { ButtonDirective };
