var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, Output, EventEmitter } from '@angular/core';
import { DomAttr } from '../../commons/extends/attr.class';
var DropdownComponent = /** @class */ (function (_super) {
    __extends(DropdownComponent, _super);
    function DropdownComponent() {
        var _this = _super.call(this) || this;
        _this.valueChange = new EventEmitter();
        _this.itemChange = new EventEmitter();
        _this.items = [];
        return _this;
    }
    Object.defineProperty(DropdownComponent.prototype, "itemList", {
        get: function () {
            var _this = this;
            var items = [];
            // just need some number value
            if (this.useNumber >= 0) {
                this.items.some(function (item, index) {
                    if (typeof item !== 'string') {
                        console.error('useNumber >= 0,items element must be a string', item);
                        return false;
                    }
                    items.push({ value: _this.useNumber + index, text: item });
                });
            }
            else {
                // diy item value
                this.items.forEach(function (item) {
                    items.push(typeof item === 'string' || typeof item === 'number' ? { value: item, text: item } : item);
                });
            }
            return items;
        },
        enumerable: true,
        configurable: true
    });
    DropdownComponent.prototype.ngOnChanges = function (changes) {
        if (changes.value) {
            var items = this.itemList;
            for (var i = 0; i < items.length; i++) {
                if (items[i].value === changes.value.currentValue) {
                    this.item = items[i];
                }
            }
        }
    };
    DropdownComponent.prototype.itemClick = function (item) {
        this.item = item;
        this.valueChange.emit(item.value);
        this.itemChange.emit(item);
    };
    DropdownComponent.prototype.trackByHeroes = function (index, item) { return item.value; };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DropdownComponent.prototype, "text", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], DropdownComponent.prototype, "value", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], DropdownComponent.prototype, "items", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DropdownComponent.prototype, "dropup", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], DropdownComponent.prototype, "useNumber", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DropdownComponent.prototype, "valueChange", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], DropdownComponent.prototype, "itemChange", void 0);
    DropdownComponent = __decorate([
        Component({
            selector: 'ts-dropdown',
            template: "\n    <div tsDropdown [dropup]=\"dropup\">\n        <button [lg]=\"lg\" [sm]=\"sm\" [outline]=\"outline\" [color]=\"color\" tsToggle>{{item ? item.text : text}}</button>\n        <div tsDropMenu>\n            <button [class.active]=\"item.value === value\"\n                    class=\"dropdown-item\"\n                    *ngFor=\"let item of itemList; trackBy: trackByHeroes\"\n                    (click)=\"itemClick(item)\">{{item.text}}</button>\n        </div>\n    </div>\n    "
        }),
        __metadata("design:paramtypes", [])
    ], DropdownComponent);
    return DropdownComponent;
}(DomAttr));
export { DropdownComponent };
