var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { ElementRef, Directive, Input, ContentChild, forwardRef, HostBinding, HostListener } from '@angular/core';
import { ToggleDirective } from '../../commons/directives/toggle.directives';
var DropdownDirective = /** @class */ (function () {
    function DropdownDirective(elementRef) {
        this.elementRef = elementRef;
        this.dropup = null;
        this.class = 'btn-group';
    }
    DropdownDirective.prototype.onDocumentClick = function (dom) {
        if (!this.isClose() && !this.elementRef.nativeElement.contains(dom)) {
            this.dismiss();
        }
    };
    DropdownDirective.prototype.ngOnInit = function () {
        this.class += (this.dropup === null ? '' : ' dropup');
    };
    DropdownDirective.prototype.ngAfterViewInit = function () {
        var _this = this;
        this.toggleDirective.target = this;
        this.toggleDirective.dom.type = 'button';
        this.toggleDirective.dom.className = this.toggleDirective.btnClass + ' dropdown-toggle';
        this.dropMenuDirective.onClick = function () {
            _this.toggle();
        };
    };
    DropdownDirective.prototype.toggle = function () {
        this.dropMenuDirective.dom.style.display === 'block' ? this.dismiss() : this.present();
    };
    DropdownDirective.prototype.isClose = function () {
        return this.dropMenuDirective.dom.style.display !== 'block';
    };
    DropdownDirective.prototype.present = function () {
        this.dropMenuDirective.setShow(this.dropup !== null, this.toggleDirective.elementRef.nativeElement.clientHeight);
    };
    DropdownDirective.prototype.dismiss = function () {
        this.dropMenuDirective.setHidden();
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], DropdownDirective.prototype, "dropup", void 0);
    __decorate([
        ContentChild(forwardRef(function () { return ToggleDirective; })),
        __metadata("design:type", ToggleDirective)
    ], DropdownDirective.prototype, "toggleDirective", void 0);
    __decorate([
        ContentChild(forwardRef(function () { return DropMenuDirective; })),
        __metadata("design:type", DropMenuDirective)
    ], DropdownDirective.prototype, "dropMenuDirective", void 0);
    __decorate([
        HostBinding('class'),
        __metadata("design:type", String)
    ], DropdownDirective.prototype, "class", void 0);
    __decorate([
        HostListener('document:click', ['$event.target']),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", void 0)
    ], DropdownDirective.prototype, "onDocumentClick", null);
    DropdownDirective = __decorate([
        Directive({
            selector: "[tsDropdown]",
            exportAs: 'tsDropdown'
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], DropdownDirective);
    return DropdownDirective;
}());
export { DropdownDirective };
var DropMenuDirective = /** @class */ (function () {
    function DropMenuDirective(elementRef) {
        this.elementRef = elementRef;
        this.class = 'dropdown-menu';
    }
    DropMenuDirective.prototype.ngAfterViewInit = function () {
        this.dom = this.elementRef.nativeElement;
        this.dom.style.top = '0';
        this.dom.style.left = '0';
    };
    DropMenuDirective.prototype.setPostion = function (dropup, btnHeight) {
        if (dropup === void 0) { dropup = false; }
        if (dropup !== null && dropup !== false) {
            this.dom.style.transform = "translate3d(0px, -" + (this.dom.clientHeight + 4) + "px, 0px)";
        }
        else {
            this.dom.style.transform = "translate3d(0px, " + (btnHeight + 4) + "px, 0px)";
        }
    };
    DropMenuDirective.prototype.setShow = function (dropup, btnHeight) {
        if (dropup === void 0) { dropup = false; }
        this.dom.style.display = 'block';
        this.setPostion(dropup, btnHeight);
    };
    DropMenuDirective.prototype.setHidden = function () {
        this.dom.style.display = '';
    };
    __decorate([
        HostBinding('class'),
        __metadata("design:type", String)
    ], DropMenuDirective.prototype, "class", void 0);
    __decorate([
        HostListener('click'),
        __metadata("design:type", Object)
    ], DropMenuDirective.prototype, "onClick", void 0);
    DropMenuDirective = __decorate([
        Directive({
            selector: "[tsDropMenu]",
        }),
        __metadata("design:paramtypes", [ElementRef])
    ], DropMenuDirective);
    return DropMenuDirective;
}());
export { DropMenuDirective };
