var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, EventEmitter, Input, Output } from '@angular/core';
import { Pagination } from './pagination.class';
import { DomAttr } from './../../commons/extends/attr.class';
var PaginationComponent = /** @class */ (function (_super) {
    __extends(PaginationComponent, _super);
    function PaginationComponent() {
        var _this = _super.call(this) || this;
        _this.pageChange = new EventEmitter();
        _this.goTitle = '';
        _this.btnNum = 5;
        _this.pagination = new Pagination();
        return _this;
    }
    PaginationComponent.prototype.ngDoCheck = function () { this.setPages(); };
    PaginationComponent.prototype.sendChange = function (page) {
        if (page && this.pagination.hasPage(page)) {
            this.pagination.page = page;
            this.setPages();
            this.pageChange.emit(this.pagination);
        }
    };
    PaginationComponent.prototype.setPages = function () {
        if (!this.pagination.pageValid()) {
            this.pagination.page = 1;
        }
        this.pages = [];
        var pagination = this.pagination.clone();
        var right = 0;
        var left = 0;
        var maxLeftNum = pagination.page - 1;
        var maxRightNum = pagination.maxPage - pagination.page;
        maxRightNum = maxRightNum > 0 ? maxRightNum : 0;
        var expLeftNum = Math.ceil((this.btnNum - 1) / 2);
        var expRightNum = this.btnNum - expLeftNum - 1;
        if (maxLeftNum >= expLeftNum) {
            if (maxRightNum >= expRightNum) {
                left = expLeftNum;
                right = expRightNum;
            }
            else {
                right = maxRightNum;
                left = maxLeftNum > (this.btnNum - right - 1) ? this.btnNum - right - 1 : maxLeftNum;
            }
        }
        else {
            if (maxRightNum >= expRightNum) {
                left = maxLeftNum;
                right = maxRightNum > (this.btnNum - left - 1) ? this.btnNum - left - 1 : maxRightNum;
            }
            else {
                left = maxLeftNum;
                right = maxRightNum;
            }
        }
        for (var i = 0; i < left; i++) {
            this.pages.push(pagination.page - left + i);
        }
        this.pages.push(pagination.page);
        for (var i = 0; i < right; i++) {
            this.pages.push(pagination.page + i + 1);
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], PaginationComponent.prototype, "nextTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], PaginationComponent.prototype, "prevTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], PaginationComponent.prototype, "endTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], PaginationComponent.prototype, "startTitle", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Pagination)
    ], PaginationComponent.prototype, "pagination", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Number)
    ], PaginationComponent.prototype, "btnNum", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Array)
    ], PaginationComponent.prototype, "items", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], PaginationComponent.prototype, "goTitle", void 0);
    __decorate([
        Output(),
        __metadata("design:type", Object)
    ], PaginationComponent.prototype, "pageChange", void 0);
    PaginationComponent = __decorate([
        Component({
            selector: 'ts-pagination',
            templateUrl: './pagination.component.html',
            styleUrls: ['./pagination.component.css']
        }),
        __metadata("design:paramtypes", [])
    ], PaginationComponent);
    return PaginationComponent;
}(DomAttr));
export { PaginationComponent };
