var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { Component, Input, ViewChild } from '@angular/core';
import { ScriptService } from './../../commons/services/script.service';
var LANGUAGE = {
    html: Prism.languages.html,
    typescript: Prism.languages.typescript,
    javascript: Prism.languages.javascript,
    xml: Prism.languages.xml,
    php: Prism.languages.php,
};
export var CODE_LANGUAGE = {
    html: 'html',
    typescript: 'typescript',
    javascript: 'javascript',
    xml: 'xml',
    php: 'php',
};
var PrismComponent = /** @class */ (function () {
    function PrismComponent(script) {
        this.script = script;
        this.language = 'html';
    }
    PrismComponent.prototype.ngOnChanges = function (changes) {
        if (changes.language && changes.code) {
            var language = changes.language.currentValue || 'html';
            var code = Prism.highlight(this.code || '', LANGUAGE[language]);
            var lineLength = code.split('\n').length;
            var lineCode = '<span class="line-numbers-rows">';
            for (var i = 0; i < lineLength; i++) {
                lineCode += '<span></span>';
            }
            lineCode += '</span">';
            this.codePad.nativeElement.innerHTML = "" + code + lineCode;
        }
    };
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], PrismComponent.prototype, "language", void 0);
    __decorate([
        Input(),
        __metadata("design:type", String)
    ], PrismComponent.prototype, "code", void 0);
    __decorate([
        Input(),
        __metadata("design:type", Object)
    ], PrismComponent.prototype, "codeStyle", void 0);
    __decorate([
        ViewChild('pad'),
        __metadata("design:type", Object)
    ], PrismComponent.prototype, "codePad", void 0);
    PrismComponent = __decorate([
        Component({
            selector: 'ts-prism',
            template: "<pre class=\"line-numbers {{'language-'+language}} rounded-0\"\n                    [ngStyle]=\"codeStyle||{}\"><code class=\"{{'language-'+language}}\" #pad></code></pre>",
            providers: [
                ScriptService
            ],
        }),
        __metadata("design:paramtypes", [ScriptService])
    ], PrismComponent);
    return PrismComponent;
}());
export { PrismComponent };
